# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

# Declaring specific app values (TO CHANGE)
bin_name_string = 'mumble-%s.msi'
silent_inst_arg = '/qn /norestart'
uninstall_key = ''

def install():

    # The file uninstall key is msi is different from the installed key

    def get_mumble_version():
        return [mumble for mumble in installed_softwares('Mumble') if mumble['name'] == 'Mumble %s' % package_version]

    package_version = control.get_software_version()
    impacted_process = control.impacted_process
    package_name = bin_name_string % package_version

    if (not get_mumble_version()) or force:
        killalltasks(impacted_process)
        run(r'msiexec %s /i "%s"' % (silent_inst_arg,package_name))
        if (not get_mumble_version()) :
            error('Not found Mumble in % version' % package_version)
        uninstallkey.append(get_mumble_version()[0]['key'])
    else:
        print('%s is already installed.' % control.asrequirement() )



def session_setup():
    print('Session setup for %s' % control.asrequirement())
    print('Disabling : update check, telemetry, overlay')
    registry_set(HKEY_CURRENT_USER,r'Software\\Mumble\\Mumble\\ui','updatecheck','false')
    registry_set(HKEY_CURRENT_USER,r'Software\\Mumble\\Mumble\\ui','usage','false')
    registry_set(HKEY_CURRENT_USER,r'Software\\Mumble\\Mumble\\ui','plugincheck','false')
    registry_set(HKEY_CURRENT_USER,r'Software\\Mumble\\Mumble\\overlay','enable','false')



def update_package():
    print('Update package content from upstream binary sources')
    from waptpackage import PackageEntry
    import json

    app_name = control.name
    url = control.sources

    # Get Proxy informations from WAPT settings
    proxies = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxies = {'http':proxywapt,'https':proxywapt}

    binaryfile = None
    for p in json.loads(wgets('https://api.github.com/repos/mumble-voip/mumble/releases',proxies=proxies)):
        if 'assets' in p:
            for u in p['assets']:
                if ('.msi' in u['name']) and (not ('x64' in u['name'])):
                    binaryfile = u['name']
                    url_dl = u['browser_download_url']
                    break
        if binaryfile:
            break


    version = url_dl.split('/')[-2]

    print('Latest ' + app_name + ' version is: ' + version)
    print('Download url is: ' + url_dl)

    latest_bin = bin_name_string % version

    # Deleting outdated binaries
    for actual_bin in glob.glob('*.msi'):
        if actual_bin != latest_bin :
            print(actual_bin + ' Deleted')
            remove_file(actual_bin)

    # Downloading latest binaires
    if not isfile(latest_bin):
        print('Downloading ' + url_dl)
        wget(url_dl,latest_bin,proxies=proxies)

        control.version = version + '-0'
        control.save_control_to_wapt()
        print ('Update package done. You can now build-upload your package')
    else:
        print ('This package is already up-to-date')

